package matt.applications;

import org.apache.log4j.Logger;

import matt.adapters.MessageSource;
import matt.adapters.MessageTarget;
import matt.implementation.Controller;
import matt.implementation.DirectorySource;
import matt.implementation.FileTarget;
import matt.implementation.Terminal;
import matt.protocol.Participant;
import matt.protocol.Runtime;

public final class Client {

  static Logger log = Logger.getLogger(Client.class);

  public static void main(
    String[] args) {

    final Runtime runtime = new Runtime(args);
    final Participant participant = new Participant();
    final MessageSource source = new DirectorySource(runtime);;
    final MessageTarget target = new FileTarget(runtime);
    final Controller relay = new Controller(participant, source, target);
    runtime.register(participant);
    relay.run();
    participant.dispose();
    runtime.dispose();
  }
}
