package matt.protocol;

import Ice.Current;
import matt.MattNoMessageException;
import matt.MattNotActiveException;
import matt.messaging.MailboxPrx;

public class Participant {

  class Impl
    extends
      matt.roles.Participant {

    private final Mailbox mailbox;

    Impl(
      final Mailbox mailbox) {
      this.mailbox = mailbox;
    }

    public void setMailbox(
      MailboxPrx mailbox,
      Current current) {
      this.mailbox.setMailbox(mailbox);
    }
  }

  private final Mailbox mailbox = new Mailbox();
  final Impl implemtnation = new Impl(mailbox);

  public void sendMessage(
    final String message)
    throws MattNotActiveException,
      InterruptedException {
    mailbox.sendMail(message);
  }

  public final boolean hasMessages()
    throws InterruptedException {
    return !mailbox.empty();
  }

  public final String receiveMessage()
    throws MattNoMessageException,
      MattNotActiveException,
      InterruptedException {
    return mailbox.receiveMail();
  }

  public void dispose() {
    int i = 10;
    while (--i != 0) {
      try {
        mailbox.dispose();
        break;
      }
      catch (InterruptedException e) {
        // TODO
      }
    }
  }

  public void whileMailboxIsActive()
    throws InterruptedException {
    mailbox.whileActive();
  }
}
